from twisted.application import service
from twisted.application import internet

from nevow import appserver
from nevow import inevow
from nevow import loaders
from nevow import rend
from nevow.stan import directive

class Simple(rend.Page):    

    docFactory = loaders.xmlfile('simplehtml.html')

    def render_theTitle(self, context, data):
        return context.tag["Welcome to Nevow world"]
    
    def render_sample(self, context, data):
        request = inevow.IRequest(context)
        session = inevow.ISession(context)
        count = getattr(session, 'count', 1)
        session.count = count + 1
        greeting = ["Welcome, person from ", request.client[1], "! You are using ", 
                        request.getHeader('user-agent'), " and have been here ", str(count), " times."]
        return context.tag[''.join(greeting)]
    
application = service.Application("simple")
internet.TCPServer(
    8080, 
    appserver.NevowSite(
        Simple()
    )
).setServiceParent(application)